Name:		tlinux-irqaffinity	
Version:	0.9
Release:	8%{?dist}
Summary:	Set irq and rps affinity for Multi-queue netcards

Group:		System Environment/Base	
License:	Tencent
BuildArch: 	noarch
URL:		www.tencent.com	
Source0:	%{name}-%{version}.tar.bz2
BuildRoot:	%(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)

Requires(post):       /sbin/chkconfig
Requires(preun):       /sbin/chkconfig

%description
setting up irq affinity according to /proc/irq/*/eth*
intel, broadcom, mellanox and chelsio netcards are supported.
setting up megasas affinity according to /proc/interrupts.
setting up mpt3sas affinity according to /proc/interrupts.
setting up mpt2sas affinity according to /proc/interrupts.
setting up nvme affinity according to /proc/interrupts.
setting up vmd affinity according to /proc/interrupts.
setting up irq affinity for network card using amd cpu.

%prep
%setup -q

%build

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/etc/init.d
mkdir -p $RPM_BUILD_ROOT/usr/sbin
install -m 755 irqaffinity $RPM_BUILD_ROOT/etc/init.d/
install -m 755 tlinux_set_irq_affinity.sh $RPM_BUILD_ROOT/usr/sbin/
install -m 755 tlinux_set_rps_cpus.py $RPM_BUILD_ROOT/usr/sbin/
install -m 755 tlinux_set_irq_nvme.sh $RPM_BUILD_ROOT/usr/sbin/
install -m 755 tlinux_set_irq_vmd_corebalance.sh $RPM_BUILD_ROOT/usr/sbin/
install -m 755 tlinux_set_irq_megasas.sh $RPM_BUILD_ROOT/usr/sbin/
install -m 755 tlinux_set_irq_mpt3sas.sh $RPM_BUILD_ROOT/usr/sbin/
install -m 755 tlinux_set_irq_mpt2sas.sh $RPM_BUILD_ROOT/usr/sbin/
install -m 755 tlinux_set_irq_affinity_amd.sh $RPM_BUILD_ROOT/usr/sbin
install -m 755 tlinux_set_rps_cpus_amd.py $RPM_BUILD_ROOT/usr/sbin/
install -m 755 tlinux_set_irq_affinity_mlnx.sh $RPM_BUILD_ROOT/usr/sbin/
install -m 755 mlnx_set_irq_affinity.sh $RPM_BUILD_ROOT/usr/sbin/
install -m 755 mlnx_set_irq_affinity_bynode.sh $RPM_BUILD_ROOT/usr/sbin/
install -m 755 mlnx_common_irq_affinity.sh $RPM_BUILD_ROOT/usr/sbin/
%post
/sbin/chkconfig --add irqaffinity

%preun
if [ $1 = 0 ] ; then
  service irqaffinity stop > /dev/null 2>&1
  /sbin/chkconfig --del irqaffinity
fi

%postun 
if [ "$1" -ge "1" ]; then
  service irqaffinity restart > /dev/null 2>&1 || :
fi

%posttrans
if [ $1 = 0 ] ; then
  /sbin/chkconfig --add irqaffinity
fi

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%config %attr(0755,root,root) /etc/init.d/irqaffinity 
%config %attr(0755,root,root) /usr/sbin/tlinux_set_irq_affinity.sh
%config %attr(0755,root,root) /usr/sbin/tlinux_set_rps_cpus.py
%config %attr(0755,root,root) /usr/sbin/tlinux_set_irq_nvme.sh
%config %attr(0755,root,root) /usr/sbin/tlinux_set_irq_vmd_corebalance.sh
%config %attr(0755,root,root) /usr/sbin/tlinux_set_irq_megasas.sh
%config %attr(0755,root,root) /usr/sbin/tlinux_set_irq_mpt3sas.sh
%config %attr(0755,root,root) /usr/sbin/tlinux_set_irq_mpt2sas.sh
%config %attr(0755,root,root) /usr/sbin/tlinux_set_irq_affinity_amd.sh
%config %attr(0755,root,root) /usr/sbin/tlinux_set_rps_cpus_amd.py
%config %attr(0755,root,root) /usr/sbin/tlinux_set_irq_affinity_mlnx.sh
%config %attr(0755,root,root) /usr/sbin/mlnx_set_irq_affinity_bynode.sh
%config %attr(0755,root,root) /usr/sbin/mlnx_set_irq_affinity.sh
%config %attr(0755,root,root) /usr/sbin/mlnx_common_irq_affinity.sh

%changelog
* Wed Aug 4 2021 Lin Yi <nilusyi@tencent.com> - 0.9-8
- Add Mellanox netcard support

* Mon Jun 21 2021 Roy Ye <royye@tencent.com> - 0.9-7
- Update tlinux_set_irq_megasas.sh
- Refer to https://bugzilla.redhat.com/show_bug.cgi?id=1908944

* Wed Jan 20 2021 Songqiao Tao <joeytao@tencent.com> - 0.9-6
- Add tlinux_set_irq_mpt2sas.sh

* Mon Jan 11 2021 Songqiao Tao <joeytao@tencent.com> - 0.9-5
- Add tlinux_set_irq_mpt3sas.sh

* Wed May  6 2020 Songqiao Tao <joeytao@tencent.com> - 0.9-4
- Update tlinux_set_rps_cpus_amd.py

* Thu Apr 16 2020 Songqiao Tao <joeytao@tencent.com> - 0.9-3
- Update tlinux_set_irq_affinity_amd.sh

* Thu Mar 26 2020 Songqiao Tao <joeytao@tencent.com> - 0.9-2
- Modify python shebang in tlinux_set_rps_cpus_amd.py and tlinux_set_rps_cpus.py

* Tue Mar 24 2020 Songqiao Tao <joeytao@tencent.com> - 0.9-1
- Update tlinux_set_irq_affinity_amd.sh, set net, nvme and ahci irq_affinity on AMD paltform

* Thu Jul 18 2019 Songqiao Tao <joeytao@tencent.com> - 0.8-15 
- Update tlinux_set_irq_nvme.sh, Add support for machines equipped with over 10 nvmes

* Sat Dec 29 2018 joshuahu <joshuahu@tencent.com> - 0.8-14
- Update "i40e-" to "/i40e" in tlinux_set_irq_affinity.sh

* Wed Dec 19 2018 Songqiao Tao <joeytao@tencent.com> - 0.8-13
- Add tlinux_set_irq_vmd_corebalance.sh

* Tue Jul 17 2018 Songqiao Tao <joeytao@tencent.com> - 0.8-12
- Update tlinux_set_rps_cpus_amd.py

* Thu Apr 26 2018 Songqiao Tao <joeytao@tencent.com> - 0.8-11
- Update tlinux_set_irq_affinity_amd.sh and tlinux_set_rps_cpus_amd.py

* Sat Feb 24 2018 Songqiao Tao <joeytao@tencent.com> - 0.8-10
- Update tlinux_set_irq_affinity_amd.sh and tlinux_set_rps_cpus_amd.sh

* Tue Dec 12 2017 Songqiao Tao <joeytao@tencent.com> - 0.8-9
- fix the rps mask value bug when cpus are more than 64
- Add setting rps while using amd cpu

* Fri Sep 29 2017 Xiaoguang Chen <xiaoggchen@tencent.com> - 0.8-8
- Add setting irq affinity while using amd cpu

* Thu Jan 12 2017 Songqiao Tao <joeytao@tencent.com> - 0.8-7
- Update tlinux_set_irq_affinity.sh, ensure the irqbalance is stopped

* Fri Nov 18 2016 Sonqiao Tao <joeytao@tencent.com> - 0.8-6
- Optimize rps set in kvm_guest
- http://tapd.oa.com/tlinux/prong/stories/view/1010024061058459167

* Mon May 16 2016 Sonqiao Tao <joeytao@tencent.com> - 0.8-5
- fix the bug using Intel 40GbE netcard
- http://tapd.oa.com/tlinux/prong/stories/view/1010024061057745729 
 
* Tue Mar 08 2016 Welson Zhang <welsonzhang@tencent.com> - 0.8-4
- fix the kvm guest set irqaffinity bug
- http://tapd.oa.com/tlinux/prong/stories/view/1010024061057501895
 
* Thu Dec 31 2015 Sonqiao Tao <joeytao@tencent.com> - 0.8-3
- Added Intel 40GbE netcard support

* Mon Nov 16 2015 Welson Zhang <welsonzhang@tencent.com> - 0.8-2
- fix the rps_cpus value bug when cpus are more than 32

* Thu Oct 15 2015 Songqiao Tao <joeytao@tencent.com> - 0.8-1
- add tlinux_set_irq_megasas.sh

* Mon Jul 20 2015 Songqiao Tao <joeytao@tencent.com> - 0.7-1
- change package name to tlinux-irqaffinity
- add tlinux_set_irq_nvme.sh

* Tue Jun  9 2015 Songqiao Tao <joeytao@tencent.com> - 0.6-2
- fix the smp_affinity value bug when cpus are more than 32

* Mon Jun  1 2015 Ruibin Li <ruibinli@tencent.com> - 0.6-1
- Also applied for pethX

* Thu May 28 2015 Songqiao Tao <joeytao@tencent.com> - 0.5.2
- fix the problem of update, modify the preun and postun

* Mon Mar 02 2015 yama <yama@tencent.com> - 0.5.1.tl2
- Add script to bind rps
- Support virtual machine now

* Sun Feb 15 2015 yama <yama@tencent.com> - 0.4-2.tl2
- Change filename to avoid conflict with other packages

* Fri Jul 11 2014 Chapman Ou <chapmanou@tencent.com> - 0.4-1.tl2
- Port to tlinux 2.0 

* Thu Nov 03 2011 Lingling Song <lynnsong@tecent.com> - 0.3-1.tl1
- create
